/*FUNTIONS TO OPERATE SERIAL PORT IN BOLT 18F2550 SYSTEM
9600 BPS FOR 18F2550 48 MHZ. PLEASE INCLUDE <usart.h> IN
MAIN FUNCTION*/

//AVAILABLE FUNCTIONS:
//STANDARD C18 LIBRARIES, USE:

// putcUSART(65); WRITES LETTER 'A' IN SERIAL PORT.

//IN THIS LIBRARY:

void activa_serial(void); //INICIALIZE SERIAL PORT 9600 BPS.
char getcECO(void);	  //READS A CHARACTER FROM SERIAL PORT SENDS ECHO.
char getcNOECO(void);	  //READS A CHARACTER FROM SERIAL PORT. DO NOT SEND ECHO.
char timed_getc(void);	  //READS A CHARACTER FROM SERIAL PORT WITH 100 MILISECONDS TIMEOUT.


void activa_serial(void)
{
OpenUSART(USART_TX_INT_OFF & USART_RX_INT_ON &
USART_ASYNCH_MODE & USART_EIGHT_BIT &
USART_CONT_RX & USART_BRGH_LOW, 77);				//SPBRG = 77 FOR 9600 BPS
} 

char timed_getc(void) 					//equivalente a getcECO(), pero con timeout de 100 milisegundos.
{							//si se vence el timeout, la subrutina regresa el valor 0.
long int timeout;
	for(timeout=0;timeout<200000;timeout++)
	{
		if(DataRdyUSART()==1)
		{
		return(getcUSART());
		}
		else continue;
	}							//hay caracter en buffer?  
	
	return(0);	
}	


/*FUNCION ESPERA UN CARACTER DEL PUERTO SERIAL, LO LEE Y*/
/*REGRESA CON EL VALOR DEL CARACTER LEIDO*/

char getcNOECO(void)
{
char a;		
		while(!DataRdyUSART());			//ESPERA BANDERA LISTA
		{
		a=getcUSART();						//LEE UN CARACTER DEL USART,NO HAY ECO
		}
return a;								
}

/*FUNCION ESPERA UN CARACTER DEL PUERTO SERIAL, LO LEE Y ENVIA EL ECO*/
/*REGRESA CON EL VALOR DEL CARACTER LEIDO*/

char getcECO(void)
{
char a;				
		while (!DataRdyUSART());			//ESPERA BANDERA LISTA
		{
		a=getcUSART();						//LEE REGISTRO DE RECEPCION DEL USART
		putcUSART(a);						//ENVIA EL ECO
		}
return a;								//REGRESA DE LA FUNCION CON CARACTER LEIDO
}
